Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt.image
Class RGBImageFilter

    java.lang.Object
      |
      +--java.awt.image.ImageFilter
            |
            +--java.awt.image.RGBImageFilter

All Implemented Interfaces:
  Cloneable, ImageConsumer

Direct Known Subclasses:
  GrayFilter

public abstract class RGBImageFilter
extends ImageFilter

This class provides an easy way to create an ImageFilter which modifies the pixels of an image in the default RGB ColorModel. It is meant to be used in conjunction with a FilteredImageSource object to produce filtered versions of existing images. It is an abstract class that provides the calls needed to channel all of the pixel data through a single method which converts pixels one at a time in the default RGB ColorModel regardless of the ColorModel being used by the ImageProducer. The only method which needs to be defined to create a useable image filter is the filterRGB method. Here is an example of a definition of a filter which swaps the red and blue components of an image:

    	class RedBlueSwapFilter extends RGBImageFilter {
    	    public RedBlueSwapFilter() {
    		// The filter's operation does not depend on the
    		// pixel's location, so IndexColorModels can be
    		// filtered directly.
    		canFilterIndexColorModel = true;
    	    }

    	    public int filterRGB(int x, int y, int rgb) {
    		return ((rgb & 0xff00ff00)
    			| ((rgb & 0xff0000) >> 16)
    			| ((rgb & 0xff) << 16));
    	    }
    	}

See Also:
  `FilteredImageSource`, `ImageFilter`, `ColorModel.getRGBdefault()`

Field Summary
`protected boolean` | `canFilterIndexColorModel` This boolean indicates whether or not it is acceptable to apply the color filtering of the filterRGB method to the color table entries of an IndexColorModel object in lieu of pixel by pixel filtering.
`protected ColorModel` | `newmodel` The `ColorModel` with which to replace `origmodel` when the user calls `substituteColorModel`.
`protected ColorModel` | `origmodel` The `ColorModel` to be replaced by `newmodel` when the user calls `substituteColorModel`.

Fields inherited from class java.awt.image.ImageFilter
`consumer`

Fields inherited from interface java.awt.image.ImageConsumer
`COMPLETESCANLINES, IMAGEABORTED, IMAGEERROR, RANDOMPIXELORDER, SINGLEFRAME, SINGLEFRAMEDONE, SINGLEPASS, STATICIMAGEDONE, TOPDOWNLEFTRIGHT`

Constructor Summary
`RGBImageFilter()`

Method Summary
`IndexColorModel` | `filterIndexColorModel(IndexColorModel icm)` Filters an IndexColorModel object by running each entry in its color tables through the filterRGB function that RGBImageFilter subclasses must provide.
`abstract int` | `filterRGB(int x, int y, int rgb)` Subclasses must specify a method to convert a single input pixel in the default RGB ColorModel to a single output pixel.
`void` | `filterRGBPixels(int x, int y, int w, int h, int[] pixels, int off, int scansize)` Filters a buffer of pixels in the default RGB ColorModel by passing them one by one through the filterRGB method.
`void` | `setColorModel(ColorModel model)` If the ColorModel is an IndexColorModel, and the subclass has set the canFilterIndexColorModel flag to true, we substitute a filtered version of the color model here and wherever that original ColorModel object appears in the setPixels methods.
`void` | `setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize)` If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel.
`void` | `setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize)` If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel, otherwise converts the buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one.
`void` | `substituteColorModel(ColorModel oldcm, ColorModel newcm)` Registers two ColorModel objects for substitution.

Methods inherited from class java.awt.image.ImageFilter
`clone, getFilterInstance, imageComplete, resendTopDownLeftRight, setDimensions, setHints, setProperties`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### origmodel

    protected ColorModel origmodel

  The `ColorModel` to be replaced by `newmodel` when the user calls `substituteColorModel`.

### newmodel

    protected ColorModel newmodel

  The `ColorModel` with which to replace `origmodel` when the user calls `substituteColorModel`.

### canFilterIndexColorModel

    protected boolean canFilterIndexColorModel

  This boolean indicates whether or not it is acceptable to apply the color filtering of the filterRGB method to the color table entries of an IndexColorModel object in lieu of pixel by pixel filtering. Subclasses should set this variable to true in their constructor if their filterRGB method does not depend on the coordinate of the pixel being filtered.
  See Also:
    `substituteColorModel(java.awt.image.ColorModel, java.awt.image.ColorModel)`, `filterRGB(int, int, int)`, `IndexColorModel`

Constructor Detail

### RGBImageFilter

    public RGBImageFilter()

Method Detail

### setColorModel

    public void setColorModel(ColorModel model)

  If the ColorModel is an IndexColorModel, and the subclass has set the canFilterIndexColorModel flag to true, we substitute a filtered version of the color model here and wherever that original ColorModel object appears in the setPixels methods. Otherwise overrides the default ColorModel used by the ImageProducer and specifies the default RGB ColorModel instead.

  Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

  Overrides:
    `setColorModel` in class `ImageFilter`
  See Also:
    `ImageConsumer`, `ColorModel.getRGBdefault()`

### substituteColorModel

    public void substituteColorModel(ColorModel oldcm,
                                     ColorModel newcm)

  Registers two ColorModel objects for substitution. If the oldcm is encountered during any of the setPixels methods, the newcm is substituted and the pixels passed through untouched (but with the new ColorModel object).
  Parameters:
    `oldcm` - the ColorModel object to be replaced on the fly
    `newcm` - the ColorModel object to replace oldcm on the fly

### filterIndexColorModel

    public IndexColorModel filterIndexColorModel(IndexColorModel icm)

  Filters an IndexColorModel object by running each entry in its color tables through the filterRGB function that RGBImageFilter subclasses must provide. Uses coordinates of -1 to indicate that a color table entry is being filtered rather than an actual pixel value.
  Parameters:
    `icm` - the IndexColorModel object to be filtered
  Returns:
    a new IndexColorModel representing the filtered colors

### filterRGBPixels

    public void filterRGBPixels(int x,
                                int y,
                                int w,
                                int h,
                                int[] pixels,
                                int off,
                                int scansize)

  Filters a buffer of pixels in the default RGB ColorModel by passing them one by one through the filterRGB method.
  See Also:
    `ColorModel.getRGBdefault()`, `filterRGB(int, int, int)`

### setPixels

    public void setPixels(int x,
                          int y,
                          int w,
                          int h,
                          ColorModel model,
                          byte[] pixels,
                          int off,
                          int scansize)

  If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel. Otherwise converts the buffer of byte pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one.

  Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

  Overrides:
    `setPixels` in class `ImageFilter`
  See Also:
    `ColorModel.getRGBdefault()`, `filterRGBPixels(int, int, int, int, int[], int, int)`

### setPixels

    public void setPixels(int x,
                          int y,
                          int w,
                          int h,
                          ColorModel model,
                          int[] pixels,
                          int off,
                          int scansize)

  If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel, otherwise converts the buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one. Converts a buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method.

  Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

  Overrides:
    `setPixels` in class `ImageFilter`
  See Also:
    `ColorModel.getRGBdefault()`, `filterRGBPixels(int, int, int, int, int[], int, int)`

### filterRGB

    public abstract int filterRGB(int x,
                                  int y,
                                  int rgb)

  Subclasses must specify a method to convert a single input pixel in the default RGB ColorModel to a single output pixel.
  See Also:
    `ColorModel.getRGBdefault()`, `filterRGBPixels(int, int, int, int, int[], int, int)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.